-- Paolo Torrini, Verimag

module Main where

import Prelude
import IO
import System
import Data.Typeable
import Language.Haskell.Parser
import Language.Haskell.Syntax
import Debug.Trace
import UDType
import TopoTree
import VVlib

main :: IO ()
main = do printStrLn ("\n Processing ... ")
          nm:_ <- getArgs
          g    <- readFile nm
          proc (parseAndCast g) nm

parseAndCast :: String -> Graphterm
parseAndCast g = case (parseModule g) of 
                   ParseOk (HsModule _ _ _ _ xs) -> 
                      let ws = [k | HsPatBind _ _ k _ <- xs]
                      in case ws of 
                           HsUnGuardedRhs j:_ -> 
                                   maybe [] id $ exp2graph j 
                           _ -> error "UDMain, main: pattern mismatch"
                   ParseFailed _ s -> error "UDMain, main: parse failure"
     
proc :: Graphterm -> String -> IO ()
proc t nm = 
 let f  = map repaint2 (map repaint t)
     g  = analyse f
     ns = concat $ map treeNames (pruneTreeX g)
     h  = map (repaint3 ns) f
 in do printAna g ns
       writeFile (nm ++ "_out") (show h)
       printStrLn ("\n" ++ "done " ++ "\n")  


