package jsbin;
// Paolo Torrini, Verimag, 2007

import java.io.*;
import java.lang.Integer;
import java.util.*;

class UD2hs {
// reads udg files and turn it into hs files. 
// first arg is project name, second one is option, other ones file names
    public static void main (String args[]) { 
        int w = args.length - 3;
        String p = args[0];
        String tag = args[1];
        String path = args[2];
// reads haskell, writes udg  
        if (tag.equals ("2ud")) {
            UDFile k = new UDFile (p, path, args[3]); 
	    String d = k.readFromHS ();  // read
            k.writeToUD (d);      // write to file
            SimpleIO.promptln ("writing UDG file done");
	} 
// reads udg, writes haskell
        else if (tag.equals ("2hs")) {       
            String[] ts = new String[w];
            SimpleIO.promptln ("");
// file names get printed
            for (int i = 0; i < w; i++) {
                String f = args[i+3];
// project name gest printed
                SimpleIO.promptln ("Reading uDrawGraph file "
                                            + path + "/" + f);
                SimpleIO.promptln ("Processing version " + args[0]);
	    }  
// content of files gets read, translated, printed to file 
// and printed out      
            for (int i = 0; i < w; i++) {
                String f = args[i+3];
                UDFile k = new UDFile (p, path, f); 
	        ts[i] = k.readFromUD ();  // read
                k.writeToHS (ts[i]);      // write to file
                SimpleIO.promptln ("");
                SimpleIO.promptln ("Printing translation to "
                       + "GHC format of file " + path + "/" + f + ": ");
                SimpleIO.promptln ("");
                SimpleIO.promptln (ts[i]);    // print out
                SimpleIO.promptln ("writing GHC module done");
            }
        }
        else SimpleIO.promptln ("wrong option");
        SimpleIO.promptln ("");
    }
}

// class for udg files
class UDFile {
    String projectNm;
    String fileNm;
    String pathNm;
    BufferedReader inR;

// constructors
    UDFile () {};
    UDFile (String p, String h, String x) {
        projectNm = p;
        pathNm = h + "/";
	fileNm = x;
    };   

// build udg filename
    public static String extFileNm (String ln) {
        int n = ln.indexOf (".udg");
        String nid = ln.substring (0, n);
        return nid;
    };

// read from an udg file and translates to Haskell format 
    public String readFromUD () {
	String line = "";
        String fnm = pathNm + extFileNm (fileNm) + ".udg";
        try {
	  inR = new BufferedReader (
			  new FileReader (fnm));
          String ln  = inR.readLine ();
          line = udg2hsk (ln);
          inR.close();
        }
        catch (IOException e) {
          System.out.println(e);
        }   
        return line;  
    };

// print out hs file
    public void writeToHS (String nt) {
        String fnm = extFileNm (fileNm);
	try {
	  String fNam0 = projectNm + "_" + fnm;
	  String fNam1 = "tmp/" + fNam0;
          String s1 = "module " + fNam0 + " where \n";
          String s2 = "import Prelude \n";
          String s3 = "import UDType \n";
          String s4 = "grX :: Graphterm \n"; 
          String s5 = "grX = ";
          String s6 = s1 + s2 + s3 + s4 + s5;
          PrintWriter out = new PrintWriter (
		    new FileOutputStream (fNam1)); 
          out.print (s6);
          out.print (nt);
          SimpleIO.promptln ("Java writing file " + fNam1);
          out.close ();
       	} catch (Exception e) { 
            System.out.println("Error: " + e);
        }
    }

// read from Haskell format and translates to udg format 
    public String readFromHS () {
	String line = "";
        try {
	  String fNam = fileNm;
	  inR = new BufferedReader (
			  new FileReader (fNam));
          String ln  = inR.readLine ();
          line = hsk2udg (ln);
          SimpleIO.promptln ("Java reading file " + fNam);
          inR.close();
        }
        catch (IOException e) {
          System.out.println(e);
        }   
        return line;  
    };

// writes to udg file
    public void writeToUD (String nt) {
        String fnm = fileNm + ".udg";
	try {
          PrintWriter out = new PrintWriter (
		    new FileOutputStream (fnm)); 
          out.print (nt);
          out.close ();
          SimpleIO.promptln ("Java writing file " + fnm);
       	} catch (Exception e) { 
            System.out.println("Error: " + e);
        }
    }

// translation function
    public String udg2hsk (String ln) { 
	String ln1  = ln.replaceAll ("\\,l\\(", "\\,L \\(");
	String ln2  = ln1.replaceAll ("\\[l\\(", "\\[L \\(");
	String ln3  = ln2.replaceAll ("\\,r\\(", "\\,R \\(");
	String ln4  = ln3.replaceAll ("\\[r\\(", "\\[R \\(");
	String ln5  = ln4.replaceAll ("\\,n\\(", "\\,N \\(");
	String ln6  = ln5.replaceAll ("\\[n\\(", "\\[N \\(");
	String ln7  = ln6.replaceAll ("\\,e\\(", "\\,E \\(");
	String ln8  = ln7.replaceAll ("\\[e\\(", "\\[E \\(");
	String ln9  = ln8.replaceAll ("\\,a\\(", "\\,A \\(");
	String ln10 = ln9.replaceAll ("\\[a\\(", "\\[A \\(");
	String ln11 = ln10.replaceAll ("\\,m\\(", "\\,M \\(");
	String ln12 = ln11.replaceAll ("\\[m\\(", "\\[M \\(");
        return ln12;
    }

    public String hsk2udg (String ln) { 
	String ln1  = ln.replaceAll ("\\,L \\(", "\\,l\\(");
	String ln2  = ln1.replaceAll ("\\[L \\(", "\\[l\\(");
	String ln3  = ln2.replaceAll ("\\,R \\(", "\\,r\\(");
	String ln4  = ln3.replaceAll ("\\[R \\(", "\\[r\\(");
	String ln5  = ln4.replaceAll ("\\,N \\(", "\\,n\\(");
	String ln6  = ln5.replaceAll ("\\[N \\(", "\\[n\\(");
	String ln7  = ln6.replaceAll ("\\,E \\(", "\\,e\\(");
	String ln8  = ln7.replaceAll ("\\[E \\(", "\\[e\\(");
	String ln9  = ln8.replaceAll ("\\,A \\(", "\\,a\\(");
	String ln10 = ln9.replaceAll ("\\[A \\(", "\\[a\\(");
	String ln11 = ln10.replaceAll ("\\,M \\(", "\\,m\\(");
	String ln12 = ln11.replaceAll ("\\[M \\(", "\\[m\\(");
        return ln12;
    }
}

